# EasyBench

シンプルで使いやすいPythonベンチマークライブラリ。

## 特徴

- 3つの柔軟なベンチマークスタイル（デコレータ、クラスベース、コマンドライン）
- 実行時間とメモリ使用量の両方を測定（[制限事項を参照](usage/class-based.md#メモリ測定の制限)）
- ボックスプロットによるベンチマーク結果の可視化で分布や外れ値を分析
- パラメータ化されたベンチマークで同一関数を異なる入力サイズで比較
- pytestライクなフィクスチャシステムでテストデータを簡単にセットアップ
- 完全なライフサイクルフック（setup/teardown）で細かいベンチマーク制御が可能
- 通常の関数実行とベンチマーク付き実行をオンデマンドで切り替え
- ソートやフォーマットオプションなど、カスタマイズ可能なベンチマーク設定
- 複数のベンチマークを一度に実行するコマンドラインツール
- 複数の出力形式（テキストテーブル、CSV、JSON、pandas.DataFrame）に対応
- カスタム出力先のための拡張可能なレポーティングシステム

## インストール

```bash
pip install easybench
```

### オプション依存関係

EasyBenchは追加機能のためのオプション依存関係をサポートしています：

```bash
# 可視化サポート付きでインストール
pip install easybench[all]
```

`all` オプションには以下が含まれます：

- `matplotlib`: ベンチマーク結果の可視化とプロット用
- `seaborn`: 強化された統計的可視化用
- `pandas`: ベンチマーク結果のDataFrame出力用
- `tqdm`: ベンチマーク実行中の進捗表示用
